# Fly config reference: https://fly.io/docs/reference/configuration/

app = "rdb-rstudio"
primary_region = "cdg"
kill_signal = "SIGINT"
kill_timeout = "30s"

[build]
  dockerfile = "Dockerfile"

[env]
  RDB_RSTUDIO_SERVER = "true"

[[mounts]]
  source = "rdb_rstudio"
  destination = "/persistent"
  initial_size = "20GB"
  auto_extend_size_increment = "10GB"
  auto_extend_size_threshold = 90

[[services]]
  protocol = "tcp"
  internal_port = 8777
  auto_stop_machines = false
  auto_start_machines = true
  min_machines_running = 0

  [services.concurrency]
    type = "connections"
    # NOTE: currently ignored since we don't scale
    hard_limit = 100
    soft_limit = 3

  [[services.ports]]
    port = 80
    handlers = ["http"]
    force_https = true

  [[services.ports]]
    port = 443
    handlers = ["tls", "http"]
    [services.ports.http_options.response.headers]
      # doc: https://fly.io/docs/reference/configuration/#services-ports-http_options-response-headers
      # Content-Security-Policy = "default-src 'self'; base-uri 'self'; form-action 'none'; frame-ancestors 'none'; script-src 'self' 'unsafe-inline'"
      Referrer-Policy = "strict-origin-when-cross-origin"
      Strict-Transport-Security = "max-age=63072000; includeSubDomains"
      X-Content-Type-Options = "nosniff"
      X-Frame-Options = "SAMEORIGIN"

  [[services.tcp_checks]]
    grace_period = "4s"
    interval = "5s"
    timeout = "2s"

[[vm]]
  cpu_kind = "performance"
  cpus = 2
  memory_mb = 8192
